---
title: Version 20.12.0
author: Sergey Yakubov
author_title: DESY IT
tags: [release]
---

#Changelog for version 20.12.0

FEATURES
* implemented possibility to send data without writing to database (no need of consecutive indexes, etc. but will not be able to consume such data)
* allow to return incomplete datasets (wihout error if one sets minimum dataset size, otherwise with "partial data" error)

 IMPROVEMENTS
* Consumer API - change behavior of GetLast/get_last - do not change current pointer after call
* Consumer API - add interrupt_current_operation to allow interrupting (from a separate thread) long consumer operation  
* Producer API - return original data in callback payload.  
* Producer API - allow to set queue limits (number of pending requests and/or max memory), reject new requests if reached the limits  
* building rpm, deb and exe packages for client libs

BREAKING CHANGES
* Consumer API - get_next_dataset, get_last_dataset, get_dataset_by_id return dictionary with 'id','expected_size','content' fields, not tuple (id,content) as before
* Consumer API - remove group_id argument from get_last/get_by_id/get_last_dataset/get_dataset_by_id functions
* Producer API - changed meaning of subsets (subset_id replaced with dataset_substream and this means now id of the image within a subset (e.g. module number for multi-module detector)), message_id is now a global id of a multi-set data (i.g. multi-image id)
    ####  renaming - general
* stream -> data_source, substream -> stream
* use millisecond everywhere for timeout/delay
* use term `message` for blob of information we send around, rename related structs, parameters, ...
* C++ - get rid of duplicate functions with default stream
    ####  renaming - Producer API
* SendData/send_data -> Send/send    
* SendXX/send_xx -> swap parameters (stream to the end)
* id_in_subset -> dataset_substream
* subset_size -> dataset_size (and in general replace subset with dataset)
    ####  renaming - Consumer API
* broker -> consumer
* SetLastReadMarker/set_lastread_marker -> swap arguments
* GetUnacknowledgedTupleIds/get_unacknowledged_tuple_ids -> GetUnacknowledgedMessages/get_unacknowledged_messages
* GetLastAcknowledgedTulpeId/get_last_acknowledged_tuple_id -> GetLastAcknowledgedMessage/get_last_acknowledged_message
* GetUnacknowledgedMessages, -> swap parameters (stream to the end)

BUG FIXES
* fix memory leak bug in Python consumer library (lead to problems when creating many consumer instances)
